
// GLOBAL VARIABLES
var ISAPP = false;
var currPageIndex = 0;
var ua = navigator.userAgent.toLowerCase();
var pageScrolls = new Array();
var at;
var prevIndex = 0;
var urlT;
var connT;
var connTimeout = 10; //alert after x seconds about connection failure
var connectionEstablished = false;
var isOffline = false;
var baseURL = "https://www.uwsuper.edu/uws/customcf/mobileapp/v5/appCore";
var masterHeight = 0;
var masterWidth = 0;
var strOS = "web";
var strOSVersion;

var isDialog = false;
var dialogTitle = "";
var authCallbackLinkId = "";
var allowLocalStorage = false;
var contactData = "";
var prevWidth = 0;
var prevHeight = 0;
var settingsMenuIsOpen = false;
var homepageLoaded = false;
var xdr;
var removeStartAt = 1000;
var removeEndAt = 1000;
var promosHTML = "";
var promosTimer;
var sessionOnlyUserID = "";
var sessionOnlyUserPW = "";
var sessionOnlyUserAccountType = "";
var sessionOnlyUserRemember = "";
var checkedCustomStartPage = false;
var targetRequest = "displayHTML";
var prevURLs = new Array();
var tmpTarget = "";
var gaPlugin;
var deviceMacAddress = "";
var panelHTML = "";
var iconC = 0;
var dimensionsTimer;
var sessionOnlyTransition = "";
var hasTapped = false;


// BROWSER DETECT
var browser = {
	chrome: false,
	mozilla: false,
	opera: false,
	msie: false,
	safari: false
};
var sBrowser, sUsrAg = navigator.userAgent;
if(sUsrAg.indexOf("Chrome") > -1) {
	browser.chrome = true;
} else if (sUsrAg.indexOf("Safari") > -1) {
	browser.safari = true;
} else if (sUsrAg.indexOf("Opera") > -1) {
	browser.opera = true;
} else if (sUsrAg.indexOf("Firefox") > -1) {
	browser.mozilla = true;
} else if (sUsrAg.indexOf("MSIE") > -1) {
	browser.msie = true;
}


// MAIN FUNCTION THAT LOADS THE PAGE
function loadPage(newPage){
	
	var pageURL = "";
	var session = "";
	var index = 0;
	var getParams = "";
	var htmlClass = $("html").attr("class");
	var orientation = "";
	var width = 0;
	var height = 0;
	var headerHeight = $("#header_" + currPageIndex).height();
	var cfid = "";
	var cftoken = "";
	var arParts = new Array();
	var postParams = "";
	var tmpTargetRequest = "";
	
	
	if( isOffline == false ){
		$.mobile.loading("show");
		arParts = newPage.split("?");
		
		width = $(window).width();
		height = $(window).height() - headerHeight;
		
		if( width > height ){
			orientation = "landscape";	
		}else{
			orientation = "portrait";	
		}

		pageURL = baseURL + arParts[0];
		
		if( arParts.length > 1 ){
			getParams = arParts[1] + "&";	
			//if( (getParams.indexOf("credentials=1") != -1) && (allowLocalStorage)){
				//postParams = "userID=" + encodeURIComponent(sessionOnlyUserID) + "&pw=" + encodeURIComponent(sessionOnlyUserPW);	
			//}
		}			

		getParams = getParams + appendRandom() + "&os=" + strOS + "&osversion=" + strOSVersion + "&orientation=" + orientation + "&browser=" + $.client.browser + "&currPageIndex=" + (currPageIndex+1);
		getParams = getParams + "&h=" + height + "&w=" + width + "&allowLocalStorage=" + allowLocalStorage + "&isApp=" + ISAPP;
		
		if( allowLocalStorage ){
			getParams = getParams + "&accountType=" + sessionOnlyUserAccountType + "&userID=" + encodeURIComponent(sessionOnlyUserID);
		}
		tmpTargetRequest = targetRequest;

		getParams = getParams + checkSession();

		connectionEstablished = false;
		startConnectionTimer(); 
		pageScrolls[currPageIndex] = $(window).scrollTop();
		prevURLs[currPageIndex] = newPage;
		
		// GA TRACKING
		if( ISAPP ){
			gaPlugin.trackPage( gaSuccessHandler, gaErrorHandler, newPage);
			if( sessionOnlyUserID != "" ){
				gaPlugin.trackEvent(gaSuccessHandler, gaErrorHandler, sessionOnlyUserAccountType + " User",newPage,"","");
			}else{
				gaPlugin.trackEvent(gaSuccessHandler, gaErrorHandler, "Anonymous User",newPage,"","");	
			}
			gaPlugin.trackEvent(gaSuccessHandler, gaErrorHandler, "Operating System",strOS + " " + strOSVersion,"","");	
			gaPlugin.trackEvent(gaSuccessHandler, gaErrorHandler, "Screen Depth",currPageIndex+1,"","");	
		}else{

			ga("send","pageview",newPage);
			if( sessionOnlyUserID != "" ){
				ga("send","event",sessionOnlyUserAccountType + " User","view",newPage,"");
			}else{
				ga("send","event","Anonymous User","view",newPage,"");
			}
			ga("send","event","Screen Depth","view",currPageIndex+1,"");
		}

		sendRequest(pageURL,getParams,postParams,tmpTargetRequest);
	}else{
		doAlert("Cannot connect to Internet. Please check your connection settings and try again.","No network connection");
	}
}

// SEND REQUEST TO SERVER
function sendRequest(pageURL,getParams,postParams,callback){
	var finalURL = pageURL;
	if( getParams != "" ){
		finalURL+= "?" + getParams;		
	}
	
	

	if( callback == "displayHTML" ){
		if( !browser.msie ){
			
			
			$.ajax({
				type: "POST",
				url: finalURL,
				data: postParams,
				dataType: "json",
				crossdomain: true,
				cache: false,
				success: function(data){
					displayHTML(data);	
				},
				error: function(jqXHR,textStatus,errorThrown){
					doAlert(errorThrown + " " + textStatus,"Error");	
					finishConnectionTimer();
				}
			});
		}else{
			if( window.XDomainRequest ){
				xdr = new XDomainRequest();
				xdr.onprogress = function(){};
				xdr.onerror = function(){};
				xdr.ontimeout = function(){};
				xdr.onload = handleIERequestPage;
				xdr.open("POST", finalURL);
				setTimeout(xdr.send(postParams),0);
			}

		}
	}else if(callback == "returnAuthentication" ){
		if( !browser.msie ){
			$.ajax({
				type: "POST",
				url: finalURL,
				data: postParams,
				dataType: "json",
				crossdomain: true,
				cache: false,
				success: function(data){
					returnAuthentication(data);	
				},
				error: function(jqXHR,textStatus,errorThrown){
					doAlert(errorThrown,"Error");
					finishConnectionTimer();	
				}
			});
		}else{
			if( window.XDomainRequest ){
				xdr = new XDomainRequest();
				xdr.onprogress = function(){};
				xdr.onerror = function(){};
				xdr.ontimeout = function(){};
				xdr.onload = handleIERequestAuth;
				xdr.open("POST", finalURL);
				xdr.send(postParams);
			}
		}
	}else if(callback == "returnSession" ){
		if( !browser.msie ){
			$.ajax({
				type: "POST",
				url: finalURL,
				data: postParams,
				dataType: "json",
				crossdomain: true,
				cache: false,
				success: function(data){
					returnSession(data);	
				},
				error: function(jqXHR,textStatus,errorThrown){
					//doAlert(errorThrown,"Error");
					//finishConnectionTimer();	
				}
			});
		}else{
			if( window.XDomainRequest ){
				xdr = new XDomainRequest();
				xdr.onprogress = function(){};
				xdr.onerror = function(){};
				xdr.ontimeout = function(){};
				xdr.onload = handleIERequestSession;
				xdr.open("POST", finalURL);
				xdr.send(postParams);
			}
		}
	}else if(callback == "returnExternal" ){
		if( !browser.msie ){
			$.ajax({
				type: "POST",
				url: finalURL,
				data: postParams,
				dataType: "json",
				crossdomain: true,
				cache: false,
				success: function(data){
					// do nothing	
				},
				error: function(jqXHR,textStatus,errorThrown){
					//doAlert(errorThrown,"Error");
					//finishConnectionTimer();	
				}
			});
		}else{
			if( window.XDomainRequest ){
				xdr = new XDomainRequest();
				xdr.onprogress = function(){};
				xdr.onerror = function(){};
				xdr.ontimeout = function(){};
				xdr.onload = handleIERequestExternal;
				xdr.open("POST", finalURL);
				xdr.send(postParams);
			}
		}
	}else if( callback == "displayPromos" ){

		if( !browser.msie ){
			$.ajax({
				type: "POST",
				url: finalURL,
				data: postParams,
				dataType: "json",
				crossdomain: true,
				cache: false,
				success: function(data){
					displayPromos(data);	
				},
				error: function(jqXHR,textStatus,errorThrown){
					//doAlert(errorThrown + " " + textStatus,"Error");	
					finishConnectionTimer();
				}
			});
		}else{
			if( window.XDomainRequest ){
				xdr = new XDomainRequest();
				xdr.onprogress = function(){};
				xdr.onerror = function(){};
				xdr.ontimeout = function(){};
				xdr.onload = handleIERequestPromos;
				xdr.open("POST", finalURL);
				xdr.send(postParams);
			}

		}
	}
	finishConnectionTimer();
	targetRequest = "displayHTML";
}

function handleIERequestPage(){
	var obj = $.parseJSON(xdr.responseText);
	displayHTML(obj);
}

function handleIERequestAuth(){
	var obj = $.parseJSON(xdr.responseText);
	returnAuthentication(obj);
}

function handleIERequestSession(){
	var obj = $.parseJSON(xdr.responseText);
	returnSession(obj);
}

function handleIERequestExternal(){
	// do nothing
}

function handleIERequestPromos(){
	var obj = $.parseJSON(xdr.responseText);
	displayPromos(obj);
	
}

// UTILITY: APPEND A RANDOM NUMBER TO URL TO PREVENT CACHING
function appendRandom(){
	var str = "r=" + Math.floor(Math.random()*1001);
	return str;
}

// START THE CONNETION TIMER
function startConnectionTimer(){
	connT = setTimeout("checkTimeout()",1000*connTimeout);
}

// RESPONSE OK: CLOSE TIMER
function finishConnectionTimer(){
	clearTimeout(connT);
	connectionEstablished = true;
	//$.mobile.hidePageLoadingMsg();	
}

// HANDLE AN ALERT FOR BOTH APP AND WEB
function doAlert(msg,title){
	if( ISAPP ){
		navigator.notification.alert(
		msg, 
		doNothing,        
		title, 
		'OK'               
		);	
	}else{
		alert(msg);
	}
	$.mobile.loading("hide");
}

// SERVER DIDN'T RESPOND FOR WHATEVER REASON
function checkTimeout(){	
	if( connectionEstablished == false ){		
		finishConnectionTimer();
		doAlert("Could not connect to UWS servers.","Connection Failure.");
	}
}

// CALLBACK FUNCTION TO DISPLAY PAGE CONTENTS
function displayHTML(results){
	var t;
	var tmp;
	var str = "";
	var np;
	var showBackButton = true;
	var dataTheme = "g";
	var css = "";
	var dataRole = "page";
	
	finishConnectionTimer();
	currPageIndex++;
	
	if( isDialog ){
		//dataTheme = "b";	
		dataRole = "dialog";
	}
	if( !isDialog ){
		str = '<div data-role="panel" id="panel' + currPageIndex + '" data-theme="' + dataTheme + '" data-position="right" data-display="overlay" class="panel">' + panelHTML + '</div>';	
	}
	str+= '<div data-role="' + dataRole + '" data-close-btn="none" id="page' + currPageIndex + '" data-url="page' + currPageIndex + '">';	
	str+= '<div data-role="header" id="header' + currPageIndex + '" data-theme="' + dataTheme + '">';
	
	// HEADER FOR NORMAL PAGE
	if( !isDialog ){
		
		if( (strOS == "Linux") && (ISAPP == true)){
			showBackButton = false;
		}
		if( showBackButton == true ){
			str+= '<a href="javascript:goBack(' + (currPageIndex-1) + ');" data-icon="back" data-iconpos="notext" data-theme="d">Back</a>';	
		}
		str+= '<div style="text-align: center;"><img src="images/logo-header.png" border="0" alt="Home" height="42" width="109" /></div>';
		str+= '<a href="javascript:doPanel(\'open\');" data-icon="bars" data-iconpos="notext" data-theme="d">Home</a>';
		css = 'class="content" style="min-height: ' + masterHeight + 'px; min-width=' + masterWidth + 'px;"';
	
	// HEADER FOR DIALOG
	}else{
		if( dialogTitle == "" ){
			dialogTitle = "&nbsp;";	
		}
		str+= '<a href="javascript:closeDialog();" data-icon="delete" data-iconpos="notext" data-theme="d">Close</a>';
		str+= '<h3 style="text-align:center;">' + dialogTitle + '</h3>';
	}
	str+= '</div>';
    str+= '<div data-role="content" id="content' + currPageIndex + '" data-theme="' + dataTheme + '" ' + css + ' data-iscroll>' + results.html + '</div>';
	str+= '</div>';
	
	// APPEND TO PAGE
	np = $(str);
	np.appendTo($.mobile.pageContainer);
	$("#page" + currPageIndex).page();	
	$("#panel" + currPageIndex).panel().enhanceWithin();
	
	// FORMAT EXTERNAL LINKS
	formatExternalLinks();
	
	// REMOVE DEFAULT CLOSE BUTTON FOR DIALOGS
	//if( isDialog ){
		//$('#header' + currPageIndex ).find('a[href=#]').remove();
	//}	
	
	// RESET DIALOG VARIABLES
	isDialog = false;	
	dialogTitle = "";

	
	// GO TO THE PAGE
	gotoPage(false,dataRole);

	// MANAGE CF SESSION
	if( currPageIndex == 0 ){
		cfid = $("#cfid").text();
		cftoken = $("#cftoken").text();	
	}
	
	hasTapped = false;
		
}

// EXTERNAL CLICKS
function doExternal(title,extURL){
	targetRequest = "returnExternal";
	loadPage("/external/index.cfm?dest=" + title);
	//$.mobile.hidePageLoadingMsg();	
	$.mobile.loading("hide");
	if( extURL != ""){
		window.open(extURL,"_system");
	}
}


// FORMAT EXTERNAL LINKS
function formatExternalLinks(){
	var title = "";
	var href = "";
	var links = $("#page" + currPageIndex + " a").each(function(){		
		if( this.href.substr(0,4) == "http" ){
			title = this.title.replace("'","");	
			if( title == "" ){
				title = this.text.replace("'","");	
			}
			href = this.href;
			if( href.indexOf("%27") != -1 ){
				href = encodeURIComponent(href);	
			}
			this.href = "javascript:doExternal('" + title + "','" + href + "');";	
			this.target = "";
		}
	});	
}

// THE BACK BUTTON
function goBack(index){
	var role = "page";
	
	removeStartAt = index+1;
	removeEndAt = currPageIndex;	
	currPageIndex = index;
	if( isPageADialog(index+1) ){
		role = "dialog";	
	}
	if( index == 0) {
		loadHomepage();
	}
	gotoPage(true,role);
	
	setTimeout("removePages()",300);	
}

// REMOVE PAGES
function removePages(){
	var theLink = "";
	for(j=removeStartAt;j<=removeEndAt;j++){
		$("#page" + j).remove();
		$("#panel" + j).remove();	
	}
	removeStartAt = 1000;
	removeEndAt = 1000;	
}

// CLOSE A DIALOG
function closeDialog(){
	$("#page" + currPageIndex).dialog("close");
	
	removeStartAt = currPageIndex;
	removeEndAt = currPageIndex;
	setTimeout("removePages()",300);
	
	currPageIndex = currPageIndex-1;
	settingsMenuIsOpen = false;		
	gotoScroll();
}


// DISPLAY PAGE
function gotoPage(direction,theRole){
	var localTransition = sessionOnlyTransition;
	
	if( currPageIndex != 0 ){
		$("#uwsContainer").css("position","absolute");
		$(".content").css("overflow","hidden");
	}

	prevIndex = currPageIndex;	

	// GO TO TOP OF PAGE
	if( direction == false ){
		setTimeout("gotoScrollTop()",100);
		
	}else{
		setTimeout("gotoScroll()",100);
	}	
	
	if(theRole == "dialog" ){
		localTransition = $.mobile.defaultDialogTransition;	
	}
	
	$.mobile.changePage("#page" + currPageIndex, {reverse:direction, changeHash:false, role: theRole, transition: localTransition});
}


function updateTransition(value){
	sessionOnlyTransition = value;
	setKey("transition",value);	
}


// SCROLL FUNCTIONS
function gotoScroll(){
	if( currPageIndex != 0 ){
		$.mobile.silentScroll(pageScrolls[currPageIndex]);	
		$("#uwsContainer").css("position","");
		$(".content").css("overflow","");	
		//$(".content").css("padding-top","67px");
	}
}

function gotoScrollTop(){
	$.mobile.silentScroll(1);
	$("#uwsContainer").css("position","");
	$(".content").css("overflow","");
}


// SET ONLINE/OFFLINE STATUS
function checkOffline(){
	isOffline = true;
}

function checkOnline(){
	isOffline = false;
	loadSession();
	//initializePromos();
}

// BACK BUTTON OVERRIDE
function checkBackButton(){
	if( currPageIndex > 0 ){
		goBack(currPageIndex-1);
	}else{
		if( ISAPP ){
			navigator.app.exitApp();	
		}
	}
}

// CALLBACK FUNCTION FOR ALERTS
function doNothing(){
	$.mobile.pageLoading(true);	
}

// UTILITY TO SHOW UWS LOGIN DIALOG
function doInitLogin(callbackLinkId){
	if( sessionOnlyUserID == "" ){
		tmpTarget = callbackLinkId;
		isDialog = true;
		dialogTitle = "UWS Authentication";
		authCallbackLinkId = callbackLinkId;
		loadPage("/settings/index.cfm?isDialog=true&showAll=false");	
	}else{
		doLogin(callbackLinkId);	
	}

}

// HANDLE AUTHENTICATION
function sendAuthentication(){
	var userID = $("#userID").val();
	var pw = $("#pw").val();
	var remember = $("#remember").val();
	var pageURL = baseURL + "/settings/index.cfm?" + appendRandom() + checkSession();
	var postParams = "userID=" + encodeURIComponent(userID) + "&pw=" + encodeURIComponent(pw);
	var getParams = "&view=authenticate";
	var tmp = new Array();

	setKey("remember",remember);
	if( userID != "" && pw != "" ){
		sendRequest(pageURL,getParams,postParams,"returnAuthentication");	
	}

	if( userID == "" || pw == ""){
		$("#pw").attr("value","");
		$("#userID").attr("value","");
		sessionOnlyUserPW = "";
		sessionOnlyUserID = "";
		sessionOnlyUserAccountType = "";
		doAlert("Your UWS username/password has been removed from this app.","Security Notification");
		setKey("userID","");
		setKey("pw","");
		setKey("remember","");
		setKey("accountType","");
		//for(k=0;k<homepageIcons.length;k++){
			//if( homepageIcons[k].icon == "links"){
				//homepageIcons[k].url = "/links/index.cfm";	
			//}
		//}
		
		// REMOVE AUTH ONLY HOMEPAGE LINKS
		
		for(k=0;k<homepageIcons.length;k++){
			if( !homepageIcons[k].authOnly ){
				a = homepageIcons[k];
				tmp[tmp.length] = new homepageIcon(a.icon,a.title,a.url,a.required,a.isOriginal,a.authOnlyType);
			}
		}
		homepageIcons = new Array();
		homepageIcons = tmp;
		if( isDialog == false ){
			goBack(0);
		}
		//loadPage(prevURLs[currPageIndex]);
	}	
}	

// HANDLE THE RETURN AUTHENTICATION FROM SERVERS
function returnAuthentication(results){
	var msg = "";

	if(results.html != ""){
		sessionOnlyUserID = $("#userID").val();
		sessionOnlyUserRemember = $("#remember").val();
		$("#userInfo").html(results.html);
		sessionOnlyUserAccountType = $("#authAccountType").html();
		sessionOnlyUserPW = $("#authPW").html();

		appendAuthOnlyHPIcons();

		if( allowLocalStorage){			
			if( sessionOnlyUserRemember == true ){
				setKey("userID",sessionOnlyUserID);
				setKey("pw",sessionOnlyUserPW);
				setKey("remember",sessionOnlyUserRemember);
				setKey("accountType",sessionOnlyUserAccountType);
			}else{
				setKey("userID","");
				setKey("pw","");
				setKey("remember","");
				setKey("accountType","");	
			}
		}
		if( authCallbackLinkId == "" ){
			if( sessionOnlyUserRemember == "" ){
				msg = "\nIt will not be remembered after you exit this app.";	
			}
			doAlert("Your UWS Username/Password have been saved." + msg,"Success");
						
			goBack(0);
			//alert(prevURLs[currPageIndex]);
			//setTimeout("loadPage(prevURLs[currPageIndex])",300);
		}else{
			//if( isDialog ){
				//closeDialog();	
			//}
			//loadPage(prevURLs[currPageIndex]);
			if( authCallbackLinkId != "digestlink"){
				doLogin(tmpTarget);
			}//else{				
				goBack(0);	
			//}
		}
		authCallbackLinkId = "";
		if( ISAPP ){
			gaPlugin.setVariable( gaSuccessHandler, gaErrorHandler, 1, "Authenticated " + sessionOnlyUserAccountType);
		}
	}else{
		doAlert("Authentication Failed. Please try again.","Invalid Username/Password.");
	}
}	

// UTILITY TO SEE IF A PAGE IS A DIALOG OR NOT
function isPageADialog(index){
	var booIsDialog = false;
	if( $("#page" + index).attr("data-role") == "dialog" ){
		booIsDialog = true;	
	}
	return booIsDialog;
}

// UTILITY FUNCTION- FIXES THE CONTENT'S HEIGHT IF CONTENT IS LESS THAN WINDOW HEIGHT
function fixHeight() {	
	var headerHeight = 47;
	var contentCurr = 0;
	var content_height = 0;
	var content_width = 0;
	//var footerHeight = 0;
	
	if( !isPageADialog(currPageIndex) ){
		
		contentCurr = $("#content" + currPageIndex);
		content_height = $(window).height();
		content_width = $(window).width();
		if( !ISAPP && (strOS.indexOf("iPhone") != -1 || strOS.indexOf("Linux") != -1)){
			content_height = content_height + headerHeight + 60;	
		}
		//if( currPageIndex == 0 ){		
			if( prevWidth != content_width || !homepageLoaded){
				loadHomepage();	
			}
			
			if( !homepageLoaded  ){
				$("#homepageCover").css("height",$(window).height());
				$("#homepageCover").css("width",$(window).width());
			}
		
			$("#content0").css("width",$(window).width());	
			$("#content0").css("height",$(window).height());		
			

			if( !homepageLoaded ){
				$("#homepageCover").fadeOut("medium",function(){
					homepageLoaded = true;
				});
			}
			
		//}else{
		if( currPageIndex > 0 ){	
			$("#map_canvas").css("height",content_height);
		}
		
		for(i=1;i<=currPageIndex;i++){
			$("#content" + i).css("min-height",content_height);
			$("#content" + i).css("min-width",content_width);	
		}	
		
		//setBodyScale();
		masterHeight = content_height;
		masterWidth = content_width;
		prevWidth = $(window).width();
		prevHeight = $(window).height();
	}
};


// ADD TO FAVS/MOST RECENT
function addToFavs(what,id,linkId){
	var items = ""
	var comma = "";
	var itemsAr = new Array();
	var booAdd = true;
	var el;
	
	removeFromFavs(what,id,linkId);
	items = localStorage.getItem(what);
	
	if( items != "" ){
		comma = ",";	
	}
	items+= comma + id;

	setKey(what,items);	
		
	// UPDATE THE BUTTON
	if( linkId != "" ){
		el = $("#" + linkId);
		el.attr("href","javascript:removeFromFavs('" + what + "','" + id + "','" + linkId + "');");
		el.html(el.html().replace("Add to","Remove from"));
	}
}

// REMOVE A VALUE FROM A FAV/MOST RECENT
function removeFromFavs(what,id,linkId){
	var items = new Array();
	var newItems = new Array();
	var newItemsStr = "";
	var el;
	newItemsStr = localStorage.getItem(what);
	items = newItemsStr.split(",");

	for(i=0;i<items.length;i++){
		if( items[i] != id ){
			newItems[newItems.length] = items[i];
		}
	}

	newItemsStr = "";
	for(i=0;i<newItems.length;i++){
		if( i > 0 ){
			newItemsStr+= ",";	
		}
		newItemsStr+= newItems[i];
	}
	setKey(what,newItemsStr);

	// UPDATE THE BUTTON
	if( linkId != "" ){
		el = $("#" + linkId);
		el.attr("href","javascript:addToFavs('" + what + "','" + id + "','" + linkId + "');");
		el.html(el.html().replace("Remove from","Add to"));
	}
}

// CLEAR A FAV/MOST RECENT
function clearFav(what,title){
	setKey(what,"");
	doAlert(title + " has been cleared.");	
}


// CHECK TO SEE IF A VALUE EXISTS IN A FAVORITE
function checkFavs(what,id){
	var items = localStorage.getItem(what);	
	var found = false;
	var itemsArray = new Array();
	itemsArray = items.split(",");
	for(i=0;i<itemsArray.length;i++){
		if( (itemsArray[i] == id) && (itemsArray[i] != "") ){
			found = true;
			break;	
		}
	}
	return found;
}

// PAGE SCROLLER UTILITY- REMEMBERS PREVIOUS PAGE'S SCROLL
//$(window).scroll(function () { 
	//pageScrolls[currPageIndex] = $(window).scrollTop();
//});

// LOAD THE MAIN DIRECTORY, INCLUDING FAVORITES
function loadDirectory(){
	var showMostRecent = "";
	if( allowLocalStorage ){
		if( localStorage.getItem("directoryMostRecent") != "" ){
			showMostRecent = "1";	
		}
	}
	if( showMostRecent != "" ){
		showMostRecent = "?showMostRecent=1";	
	}
	loadPage("/directory/index.cfm" + showMostRecent);
}

// FORM TO LOG INTO SERVICES
function doLogin(target,from){
	if( isOffline ){
		doAlert("Cannot connect to Internet. Please check your connection settings and try again.","No network connection");	
	}else{
		targetTitle = target;
		iconIndex = "";
		for(k=1;k<homepageIcons.length;k++){
			if( homepageIcons[k].icon == target ){
				iconIndex = k;
				break	
			}
		}
		if( from == "home" ){
			targetTitle	= target + "&iconIndex=" + iconIndex;
		}
		doExternal(targetTitle,baseURL + "/ldaplogins/redirect.cfm?target=" + target + "&pw=" + encodeURIComponent(sessionOnlyUserPW) + "&userID=" + encodeURIComponent(sessionOnlyUserID));
	}
}

// FUNCTION TO LOAD CLASS SCHEDULES PAGE, PASS IN LIST OF FAVORITES
function loadClassSchedule(){
	var favs = "";
	if( allowLocalStorage ){
		favs = localStorage.getItem("classFavs");
	}
	loadPage("/classschedules/index.cfm?favs=" + favs);	
}

// SET LOCALSTORAGE UTILITY
function setKey(key, val){
  var hasError = false;
  try{  	
	localStorage.setItem(key, val);
  }catch(err){
		allowLocalStorage = false;
		hasError = true;
		if( err.name.toUpperCase() == "QUOTA_EXCEEDED_ERR" ){			
			doAlert("In-Private mode detected. Some features of this app will not work when using In-Private mode.","In-Private Mode");	
		}
  }
  if(!hasError){
	allowLocalStorage = true; 
  }
}



function doPanel(action){
    $('#panel' + currPageIndex).panel(action);
}




// HOMESCREEN PROMOS
function initializePromos(){	
	var numSecs = 60;
	if( isOffline == false ){
		theURL = baseURL + "/promos/index.cfm";
		//targetRequest = "displayPromos";
		sendRequest(theURL,"","","displayPromos");	
	}
	promosTimer = setTimeout("initializePromos()",numSecs*1000);

}

function displayPromos(results){	
	promosHTML = results.html;
	$("#promos").html(results.html);
}







function appendAuthOnlyHPIcons(){
	var doAdd = true;


	if( sessionOnlyUserID != "" ){
		for(j=1;j<homepageIconsOriginal.length;j++){
		
			if( homepageIconsOriginal[j].authOnlyType != "" ){
			
				// MAKE SURE IT'S NOT ALREADY IN THERE
				doAdd = true;
				for(h=1;h<homepageIcons.length;h++){
					if( homepageIcons[h].url == homepageIconsOriginal[j].url ){
						doAdd = false;
						break;	
					}
				}
				if( homepageIconsOriginal[j].authOnlyType != "both"){
					if( homepageIconsOriginal[j].authOnlyType != sessionOnlyUserAccountType){
						doAdd = false;
					}
				}
				if( doAdd ){				
					homepageIcons[homepageIcons.length] = homepageIconsOriginal[j];	
					
				}
			}	
		}
	}
	setHomepageIconsKEY();
	

}


// ADD A DEEP LINK HOMEPAGE ICON
function addHomepageIcon(theIcon,theTitle,theURL,uiType){
	homepageIcons[homepageIcons.length] = new homepageIcon(theIcon,theTitle,theURL,false,false,"");	
	homepageIconsOriginal[homepageIconsOriginal.length] = new homepageIcon(theIcon,theTitle,theURL,false,false,"",false);	
	setHomepageIconsKEY();
	$("#addToHomepage" + currPageIndex).css("display","none");
	$("#removeFromHomepage" + currPageIndex).css("display","");
	if( uiType == "li"){
		$("#addToHomepage").parent().listview("refresh");		
	}
	loadHomepage();
}

function removeHomepageIcon(theIcon,theTitle,theURL,uiType){
	var tmp = new Array();
	for(m=0;m<homepageIcons.length;m++){
		if( homepageIcons[m].url != theURL ){
			add = true;
			if( sessionOnlyUserID != "" ){
				if( homepageIcons[m].authOnlyType != "" ){
					if( homepageIcons[m].authOnlyType != "both" ){
						if( sessionOnlyUserAccountType != homepageIcons[m].authOnlyType ){
							add = false;	
						}
					}
				}
			}
			if( add ){
				tmp[tmp.length] = homepageIcons[m];
			}
		}
	}
	
	homepageIcons = tmp;

	setHomepageIconsKEY();
	
	$("#removeFromHomepage" + currPageIndex).css("display","none");
	$("#addToHomepage" + currPageIndex).css("display","");
	if( uiType == "li"){
		$("#removeFromHomepage").parent().listview("refresh");		
	}
	loadHomepage();
	
}	


// FOR THE "ADD TO HOMESCREEN" BUTTONS ON VARIOUS PAGES
function toggleHomepageButton(theURL,li){
	var found = false;
	for(m=0;m<homepageIcons.length;m++){
		if( homepageIcons[m].url == theURL ){
			found = true;
		}
	}

	if( found ){
		$("#addToHomepage" + currPageIndex).css("display","none");
		
	}else{		
		$("#removeFromHomepage" + currPageIndex).css("display","none");				
	}
	if( li ){
		$("#removeFromHomepage").parent().listview("refresh");	
	}
	

}



// SETS THE LOCAL STORAGE KEY FOR THE HOMEPAGE ICONS
function setHomepageIconsKEY(){
	var seperator = "[+]"; // DO NOT CHANGE
	var strHPIcons = "";
	var strHPTitles = "";
	var strHPLinks = "";
	
	if( allowLocalStorage ){
		for(i=0;i<homepageIcons.length;i++){
			doAdd = true;
			if( homepageIcons[i].authOnlyType != "" ){
				if( sessionOnlyUserID != "" ){
					if( homepageIcons[i].authOnlyType != "both" ){
						if( homepageIcons[i].authOnlyType != sessionOnlyUserAccountType ){
							doAdd = false;	
						}
					}
				}else{
					doAdd = false;	
				}
			}
			if( doAdd == true ){
				if( strHPIcons != "" ){
					strHPIcons+= seperator;
					strHPTitles+= seperator;
					strHPLinks+= seperator;	
				}
				strHPIcons+= homepageIcons[i].icon;
				strHPTitles+= homepageIcons[i].title;
				strHPLinks+= homepageIcons[i].url;
			}
		}
		setKey("hpIconIcons",strHPIcons);
		setKey("hpIconTitles",strHPTitles);
		setKey("hpIconLinks",strHPLinks);	
	}	
}

function getHomepageIconsKEY(){
	var seperator = "[+]"; // DO NOT CHANGE
	var arHPIcons = new Array();
	var arHPTitles = new Array();
	var arHPLinks = new Array();
	var isOrig = true;
	var isReq = true;
	var authOnlyType = false;
	
	if( allowLocalStorage ){
		if( localStorage.getItem("hpIconIcons") != "" ){
			arHPIcons = localStorage.getItem("hpIconIcons").split(seperator);
			arHPTitles = localStorage.getItem("hpIconTitles").split(seperator);
			arHPLinks = localStorage.getItem("hpIconLinks").split(seperator);
			
			homepageIcons = new Array();
			//homepageIcons[0] = new homepageIcon("","NONE","",false,true,"");
			for(i=0;i<arHPIcons.length;i++){
				doAdd = true;
				isOrig = true;
				isReq = false;
				authOnlyType = "";

				for(k=0;k<homepageIconsOriginal.length;k++){
					if( homepageIconsOriginal[k].url == arHPLinks[i] ){
						isOrig = homepageIconsOriginal[k].isOriginal;
						isReq = homepageIconsOriginal[k].required;
						authOnlyType = homepageIconsOriginal[k].authOnlyType;
						break;	
					}
				}
				//alert(arHPTitles[i] + " " + isAuthOnly);
				if( authOnlyType != "" ){					
					if( sessionOnlyUserID != "" ){
						if( authOnlyType == "both" ){
							doAdd = true;		
						}else{
							if( authOnlyType == sessionOnlyUserAccountType ){
								doAdd = true;	
							}
						}
						
					}else{
						doAdd = false;	
					}
				}
				if( doAdd ){
					homepageIcons[homepageIcons.length] = new homepageIcon(arHPIcons[i],arHPTitles[i],arHPLinks[i],isReq,isOrig,authOnlyType,false);
				}
			}
		}		
	}
}




// HOMEPAGE FUNCTIONS ---------------------------------
function homepageIcon(icon,title,url,required,isOriginal,authOnlyType,tobeDeleted){
	this.icon = icon;
	this.title = title;
	this.url = url;	
	this.required = required;
	this.isOriginal = isOriginal;
	this.authOnlyType = authOnlyType;
	this.tobeDeleted = tobeDeleted;
}

var homepageIcons = new Array();
var homepageIconsOriginal = new Array();

var x = 0;
//homepageIcons[x++] = new homepageIcon("","NONE","",false,true,"",false);
homepageIcons[x++] = new homepageIcon("news","News","/news/index.cfm",false,true,"",false);
homepageIcons[x++] = new homepageIcon("events","Events","/events/index.cfm",false,true,"",false);
homepageIcons[x++] = new homepageIcon("directory","Directory","javascript:loadDirectory();",false,true,"",false);
homepageIcons[x++] = new homepageIcon("athletics","Athletics","/athletics/index.cfm",false,true,"",false);
homepageIcons[x++] = new homepageIcon("maps","Campus/Bus Map","/maps/index.cfm",false,true,"",false);
homepageIcons[x++] = new homepageIcon("classschedules","Class Schedule","javascript:loadClassSchedule();",false,true,"",false);
homepageIcons[x++] = new homepageIcon("labs","Computer Labs","/labs/index.cfm",false,true,"",false);
homepageIcons[x++] = new homepageIcon("safety","Campus Safety","/safety/index.cfm",false,true,"",false);
homepageIcons[x++] = new homepageIcon("links","Links & Settings","/links/index.cfm",true,true,"",false);

homepageIcons[x++] = new homepageIcon("email","My Email","javascript:doLogin('email','home');",false,true,"both",false);
homepageIcons[x++] = new homepageIcon("ehive","My E-Hive","javascript:doLogin('ehive','home');",false,true,"both",false);
homepageIcons[x++] = new homepageIcon("learn","Learn@UW-Superior","/learn/index.cfm?from=home",false,true,"both",false);
homepageIcons[x++] = new homepageIcon("jacketjobs","Jacket Jobs","javascript:doLogin('jacketjobs','home');",false,true,"Students",false);


homepageIconsOriginal = homepageIcons.slice(0);


function loadHomepage(){

	var htmlStr = "";
	var iconRootDirectory = "images/homepage/";
	var iconDirectory = "icons-small/";
	var headerClass = "homepageHeader-small";
	var numPerRow = 3;
	var colC = 1;
	var homepageWidth = 0;
	var iconMargin = 10;
	var iconWidth = 72;
	var iconHeight = 70;
	var iconFontSize = 9;	
	var isOrig = false;
	var isReq = false;
	var strHPIcons = "";
	var strHPTitles = "";
	var strHPLinks = "";
	var arHPIcons = new Array();
	var arHPTitles = new Array();
	var arHPLinks = new Array();
	var loadOnlyOriginals = true;
	var visibleIcons = new Array();
	var iconBlankCorners = 16;
	var iconShadow = "2px 2px 2px #000";
	var iconCustomOffset = 4;
	var iconCustomMargin = 5;
	var strImg = "";
	
	
	// GET THE SAVED HOMEPAGE ICONS
	getHomepageIconsKEY();
	
	if( allowLocalStorage ){
		if( localStorage.getItem("hpIconIcons") == "" ){
			loadOnlyOriginals = false;
		}
	}
	
	
	if( $(window).width() > 650 ){
		iconDirectory = "icons-large/";
		headerClass = "homepageHeader-large";
		iconMargin = 20;
		iconWidth = 149;
		iconHeight = 144;
		iconFontSize = 12;
		iconBlankCorners = 30;
		iconBlankAdjustments = 10;
		iconShadow = "3px 3px 5px #000";
		iconCustomOffset = 6;
		iconCustomMargin = 6;
	}
	
	homepageWidth = (numPerRow * iconWidth) + ((iconMargin * 2) * numPerRow);
	
	for(b=0;b<homepageIcons.length;b++){
		doAdd = false;
		if( !loadOnlyOriginals ){
			if( homepageIcons[b].isOriginal ){
				doAdd = true;	
			}
		}else{
			doAdd = true;
		}
		if( homepageIcons[b].authOnlyType != "" ){
			if( sessionOnlyUserID != "" ){
				if( homepageIcons[b].authOnlyType == "both" ){
					doAdd = true;	
				}else{
					if( homepageIcons[b].authOnlyType == sessionOnlyUserAccountType ){
						doAdd = true;	
					}else{
						doAdd = false;	
					}
				}
			}else{
				doAdd = false;	
			}
			
		}
		if( doAdd ){

			visibleIcons[visibleIcons.length] = homepageIcons[b];	
		}
	}
	
	

	// DETERMINE HOW MANY ICONS PER ROW TO SHOW
	if( $(window).width() > $(window).height() ){

		for(j=0;j<visibleIcons.length;j++){
			if( visibleIcons[j].icon != "" ){
				tmpWidth = (j * iconWidth) + ((iconMargin * 2) * j);
				if( tmpWidth < $(window).width() ){
					homepageWidth = tmpWidth;
					numPerRow = j;
				}else{
					break;	
				}
			}		
		}
	}
	
	// CREATE THE HOMEPAGE UI
	htmlStr+= '<div id="homepageCover"></div>';
	htmlStr += '<div class=' + headerClass + ' id="homepageHeader">&nbsp;</div>';
	htmlStr+= '<div class="homepageIconsWrapper" style="width:' + homepageWidth + 'px;">';
	htmlStr+= '<div id="promos"></div>';
	
	panelHTML = '<ul data-role="listview"><li data-icon="home" data-theme="f"><a href="javascript:goBack(0);">Home</a></li>';
	iconC = 1;
	for(i=0;i<visibleIcons.length;i++){

		if( visibleIcons[i].icon != "" ){
			//if( visibleIcons[i].icon == "links"){
				//if( (sessionOnlyUserID != "") && (homepageIcons[i].url.indexOf("credentials") < 0) ){
					//homepageIcons[i].url+= "?credentials=1";	
				//}
			//}
			theLink = visibleIcons[i].url;
			if( visibleIcons[i].url.indexOf("javascript") == -1 ){
				theLink = "loadPage('" + visibleIcons[i].url + "');";	
			}
			title = visibleIcons[i].title;
			if( title.length > 20 ){
				title = title.substring(0,19) + "...";
			}
			tmpW = iconWidth;
			tmpH = iconHeight;
			if( visibleIcons[i].icon.indexOf("https://") != -1 ){
				tmpW = iconWidth-iconCustomOffset;
				tmpH = iconHeight-iconCustomOffset;
			}
			
			iconIndex = 0;
			for(t=0;t<homepageIcons.length;t++){
				if( homepageIcons[t].title == visibleIcons[i].title ){
					iconIndex = t;
					break;	
				}
			}
			
			htmlStr+= '<div class="homepageIcons" id="homepageIconWrapper_' + iconIndex + '" style="margin:' + iconMargin + 'px; width:' + tmpW + 'px; font-size: ' + iconFontSize + 'pt;" link="' + theLink + '">';
			
			if( visibleIcons[i].icon.indexOf("http") != -1 ){
				strImg = iconRootDirectory + iconDirectory + "blank.png";
				if( !isOffline ){
					strImg = visibleIcons[i].icon;						
				}
				htmlStr+= '<img src="' + strImg + '" id="homepageIcon_' + i + '" border="0" style="width: ' + tmpW + 'px; height: ' + tmpH+ 'px; margin-bottom: ' + iconCustomMargin + 'px; -webkit-border-radius: ' + iconBlankCorners + 'px; -moz-border-radius: ' + iconBlankCorners + 'px; border-radius: ' + iconBlankCorners + 'px; box-shadow: ' + iconShadow + ';"/>';

			}else{
				htmlStr+= '<img src="' + iconRootDirectory + iconDirectory + visibleIcons[i].icon + '.png" border="0" alt="' + visibleIcons[i].title + '"/>';
			}
			htmlStr+= '<div style="text-align: center;" class="label">' + title + '</div></div>';
			
			panelHTML+= '<li><a href="' + theLink + '">' + title + '</a></li>';
			if( colC == numPerRow ){
				htmlStr+= '<div style="clear:both;"></div>';	
				colC = 0;
			}
			colC++;
		}
	}
	panelHTML+= '</ul>';
	htmlStr+= '<div style="clear:both;"></div>';	
	htmlStr+= '</div>';
	

	$("#content0").html(htmlStr);
		
	
	$('.homepageIcons').bind('tap', tapHandler);
	
	
	$(".homepageIcons").bind( "drag", tapholdHandler );
	$(".homepageIcons").draggable({containment: $("#homepageIconsWrapper"), delay: 150});   
			
	
	$("#promos").html(promosHTML);
	if( ISAPP == false ){
		checkCustomStartPage();
	}

}


function tapHandler(e){
	if( hasTapped == false ){
		eval( $(this).attr("link") );	
		hasTapped = true;
	}
}

// HANDLE THE DRAG AND DROP OF HOMESCREEN ICONS
var tapHoldIndex;
function tapholdHandler(e){
	var tmpRecord;
	var insertIndex;
	var tmpArray = new Array();
	clearTimeout(dimensionsTimer);
	tapHoldIndex = parseInt($(this).attr("id").replace("homepageIconWrapper_",""));
	$(this).addClass("draggable");
	$("body").droppable({
		drop: function(){
			loadHomepage();	
			checkDimensions();
		}
	});
	
	for(s=0;s<homepageIcons.length;s++){
		if( s != tapHoldIndex){
			$("#homepageIconWrapper_" + s).addClass("droppable");
			$("#homepageIconWrapper_" + s).droppable({
				drop: function(){
					
					insertIndex = parseInt($(this).attr("id").replace("homepageIconWrapper_",""));
					tmpRecord = jQuery.extend({},homepageIcons[tapHoldIndex]);
					for(g=0;g<homepageIcons.length;g++){
						
						if( insertIndex < tapHoldIndex ){
							if( g == insertIndex ){
								tmpArray[tmpArray.length] = tmpRecord;	
							}
						}				
						if( tapHoldIndex != g ){
							tmpArray[tmpArray.length] = homepageIcons[g];
						}

						
						if( insertIndex > tapHoldIndex ){
							if( g == insertIndex ){
								tmpArray[tmpArray.length] = tmpRecord;	
							}
						}
					}
					homepageIcons = tmpArray;

					setHomepageIconsKEY();									
					loadHomepage();
					checkDimensions();
				}
			});
		}else{
				
		}
	}
}





// SESSION MANAGEMENT
function loadSession(){
	if( $("#sessionID").html() == "" ){
		sendRequest(baseURL + "/session.cfm","","","returnSession");
	}
}

function checkSession(){
	var str = "";
	var cfIDHolder = $("#cfid");
	var cftokenHolder = $("#cftoken");
	if( !isOffline ){
		if( cfIDHolder.text() == null ){
			loadSession();	
		}else{
			str = "&cfid=" + cfIDHolder.text() + "&cftoken=" + cftokenHolder.text();
		}
	}else{
		loadSession();	
	}
	return str;
}

function returnSession(results){
	$("#sessionID").html(results.html);
	var cfIDHolder = $("#cfid");
	var cftokenHolder = $("#cftoken");
	setKey("cfid",cfIDHolder.text());
	setKey("cftoken",cftokenHolder.text());
}

// ALWAYS CHECK DIMENSIONS OF SCREEN
function checkDimensions(){
	fixHeight();	
	dimensionsTimer = setTimeout("checkDimensions()",800);
}


// CHECK FOR CUSTOM START PAGE
function checkCustomStartPage(){
	var custom = getURLParameter("start");
	if( !ISAPP && !checkedCustomStartPage && custom != null && custom != "null"){
		custom = custom.replace("|","&");
		loadPage(custom);
	}
	checkedCustomStartPage = true;
}

function getURLParameter(name) {
    return decodeURI(
        (RegExp(name + '=' + '(.+?)(&|$)').exec(location.search)||[,null])[1]
    );
}


// OVERRIDE THE MENU BUTTON (ANDROID)
function checkMenuButton(){		
	if( settingsMenuIsOpen == false ){
		isDialog = true;
		dialogTitle = "App Settings";
		loadPage("/settings/index.cfm?isDialog=true");
		settingsMenuIsOpen = true;
	}else{
		closeDialog();	
		settingsMenuIsOpen = false;
	}
	
}



// GOOGLE ANALYTICS FUNCTIONS
function gaSuccessHandler(){
}

function gaErrorHandler(){
}


// DISPLAYS THE DEVICE"S MAC ADDRESS IN A DIV
function displayMacAddress(){
	$("#macAddressContainer").html(deviceMacAddress);
}

function gotoMyDevices(){
	window.plugins.clipboard.copy(deviceMacAddress);
	doExternal("My Devices","https://mydevices.uwsuper.edu");
}



// ONCE THE DEVICE IS READY, INITIALIZE
function onDeviceReady() {	

	// IE needs to be in SSL	
	if( browser.msie ){
		currURL = window.self.location.toString().toLowerCase();
		currSSL = currURL.indexOf("https://");
		if( currSSL == -1 ){
			newURL = currURL.replace(/http/,"https");
			window.self.location.replace(newURL);	
		}	
	}
	
	// NO RIGHT CLICK MENU FOR DRAGGING/DROPPING ISSUES
	document.oncontextmenu = function() {return false;};

    $(document).mousedown(function(e){

        if ( e.button == 2 )
        { 
            return false; 
        }

        return true;
    });
	

	// not for android or web
	//strOS = $.client.os;
	strOS = navigator.platform;
	
	if( ISAPP ){
		strOSVersion = window.device.version;
		document.addEventListener("offline", checkOffline, false);
		document.addEventListener("online", checkOnline, false);
		document.addEventListener("backbutton", checkBackButton, true);
		document.addEventListener("menubutton", checkMenuButton, false);		
		gaPlugin = window.plugins.gaPlugin;
		gaPlugin.init(gaSuccessHandler, gaErrorHandler, "UA-51246115-1", 10);		
		window.MacAddress.getMacAddress(
			function(macAddress){
				deviceMacAddress = macAddress;
			}
		);
	}else{
		checkOnline();
	}
	
	// TEST TO SEE IF LOCAL STORAGE IS SUPPORTED	
	setKey("uws",""); 

	if( allowLocalStorage ){

		keys = new Array("directoryMostRecent","classFavs","cfid","cftoken","hpIconIcons","hpIconTitles","hpIconLinks");
		for(i=0;i<keys.length;i++){
			if( localStorage.getItem(keys[i]) == null ){
				setKey(keys[i],"");	
			}
		}	
		if( localStorage.getItem("userID") == null ){
			setKey("userID","");
		}else{
			sessionOnlyUserID = localStorage.getItem("userID");	
		}
		
		if( localStorage.getItem("pw") == null ){
			setKey("pw","");
		}else{
			sessionOnlyUserPW = localStorage.getItem("pw");		
		}
		
		if( localStorage.getItem("accountType") == null ){
			setKey("accountType","");
		}else{
			sessionOnlyUserAccountType = localStorage.getItem("accountType");
		}
		
		if( localStorage.getItem("remember") == null ){
			setKey("remember","");
		}else{
			sessionOnlyUserRemember = localStorage.getItem("remember");	
		}
		
		if( localStorage.getItem("transition") == null ){
			setKey("transition",$.mobile.defaultPageTransition);
			sessionOnlyTransition = $.mobile.defaultPageTransition
		}else{
			sessionOnlyTransition = localStorage.getItem("transition");	
		}
	}
	
	if( !ISAPP ){
		(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
		  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
		  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
		  })(window,document,'script','//www.google-analytics.com/analytics.js','ga');
		
		  ga('create', 'UA-51246115-2', 'auto');
		  ga('send', 'pageview');	
	}
		
	// CHECK DIMENSIONS/LOAD HOMEPAGE
	checkDimensions();	
	
	// GET SESSION INFO
	loadSession();	
	
	// GET PROMOS
	initializePromos();	
	
	// HIDE SPLASH SCREEN
	if( ISAPP ){
		navigator.splashscreen.hide();
	}

}




// ONLOAD- GET IT ALL STARTED
$(document).bind("mobileinit", function(){	
	if( !ISAPP ){
		setTimeout("onDeviceReady()",100);
	}else{
		document.addEventListener("deviceready", onDeviceReady, false);
	}
});



